# Name:        RateMap v1.0a
#
# Author:      JoeyT2007
#
# Description: Allows players to rate their favourite maps.
#
# Commands:    !ratemap - Brings up the rating menu, or the error message if you have already rated.
#              !rate - Brings up the rating menu, or the error message if you have already rated.
#              !rm - Brings up the rating menu, or the error message if you have already rated.
#              !rating - Tells the user what the current map is rated.
#              !rating [map] - Tells the user what the chosen map is rated.
#
# Credits:     Creator         JoeyT2007
#
#              Help            NATO_Hunter
#                              R`SiN
#                              Errant

import es
from es import server_var
import popuplib
import keyvalues
import os
import playerlib

###CONFIG###
ratemap_onteam = es.ServerVar("ratemap_onteam", "1", "Make the ratemap menu popup when choosing a team?")
############

ratemap_ver = es.ServerVar("ratemap_ver", "1.0a", "Version of RateMap that you are using.")
ratemap_ver.makepublic()

def load():
    es.regsaycmd("!rm", "ratemap/sendpopup", "")
    es.regsaycmd("!rate", "ratemap/sendpopup", "")
    es.regsaycmd("!ratemap", "ratemap/sendpopup", "")
    es.regsaycmd("!rating", "ratemap/viewrating", "")
    global rm_map
    rm_map = es.ServerVar("eventscripts_currentmap")
    global rm_path
    rm_path = es.getAddonPath('ratemap') + "/data/" + rm_map + '.dat'
    if not os.path.exists(rm_path):
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey['fivestars'] = keyvalues.KeyValues(name='fivestars')
        mapkey['fivestars']['count'] = 0
        mapkey['fourstars'] = keyvalues.KeyValues(name='fourstars')
        mapkey['fourstars']['count'] = 0
        mapkey['threestars'] = keyvalues.KeyValues(name='threestars')
        mapkey['threestars']['count'] = 0
        mapkey['twostars'] = keyvalues.KeyValues(name='twostars')
        mapkey['twostars']['count'] = 0
        mapkey['onestars'] = keyvalues.KeyValues(name='onestars')
        mapkey['onestars']['count'] = 0
        mapkey.save(rm_path)
    else:
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey.load(rm_path)

def unload():
    if popuplib.exists('ratemenu'):
        popuplib.delete('ratemenu')
    es.unregsaycmd("!rm")
    es.unregsaycmd("!rate")
    es.unregsaycmd("!ratemap")
    es.unregsaycmd("!rating")

def es_map_start(event_var):
    global rm_map
    rm_map = es.ServerVar("eventscripts_currentmap")
    global rm_path
    rm_path = es.getAddonPath('ratemap') + "/data/" + rm_map + '.dat'
    if not os.path.exists(rm_path):
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey['fivestars'] = keyvalues.KeyValues(name='fivestars')
        mapkey['fivestars']['count'] = 0
        mapkey['fourstars'] = keyvalues.KeyValues(name='fourstars')
        mapkey['fourstars']['count'] = 0
        mapkey['threestars'] = keyvalues.KeyValues(name='threestars')
        mapkey['threestars']['count'] = 0
        mapkey['twostars'] = keyvalues.KeyValues(name='twostars')
        mapkey['twostars']['count'] = 0
        mapkey['onestars'] = keyvalues.KeyValues(name='onestars')
        mapkey['onestars']['count'] = 0
        mapkey.save(rm_path)
    else:
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey.load(rm_path)

def round_start(event_var):
    mapkey = keyvalues.KeyValues(name=str(rm_map))
    mapkey.load(rm_path)
    rm_steamid = es.getplayersteamid(event_var["userid"])
    if not rm_steamid in mapkey:
        es.tell(event_var["userid"], "#multi", "#green[RateMap]#default is running. Type #lightgreen!rm#default to rate this map.")
    getrating(event_var["userid"], rm_map, 2)

def viewrating():
    rm_userid = es.getcmduserid()
    rm_argcount = es.getargc()
    if rm_argcount <= 2:
       if rm_argcount == 1:
           getrating(rm_userid, rm_map, 1)
       if rm_argcount == 2:
           rm_map2 = es.getargv(1)
           getrating(rm_userid, rm_map2, 1)
    else:
       es.tell(int(rm_userid), "#multi", "#green[RateMap]#lightgreen Syntax: !rating [map]")

def sendpopup():
    rm_userid = es.getcmduserid()
    mapkey = keyvalues.KeyValues(name=str(rm_map))
    mapkey.load(rm_path)
    rm_steamid = es.getplayersteamid(rm_userid)
    if rm_steamid in mapkey:
        es.tell(rm_userid, "#multi", "#green[RateMap]#default You have already rated #lightgreen%s#default." % rm_map)
        getrating(rm_userid, rm_map, 1)
    else:
        popuprating(rm_userid)

def popuprating(rm_userid):
    if popuplib.isqueued('ratemenu', rm_userid):
        popuplib.close('ratemenu', rm_userid)
    ratemenu = popuplib.create("ratemenu")
    ratemenu.addline("[RateMap] v1.0a")
    ratemenu.addline("-------------------")
    ratemenu.addline("Map: %s" % rm_map)
    ratemenu.addline("-------------------")
    ratemenu.addline("->1. 5 Stars")
    ratemenu.addline("->2. 4 Stars")
    ratemenu.addline("->3. 3 Stars")
    ratemenu.addline("->4. 2 Stars")
    ratemenu.addline("->5. 1 Star")
    ratemenu.addline("-------------------")
    ratemenu.addline("0. Close")
    ratemenu.addline("-------------------")
    ratemenu.addline("By JoeyT2007")
    ratemenu.select(1, setrating)
    ratemenu.select(2, setrating)
    ratemenu.select(3, setrating)
    ratemenu.select(4, setrating)
    ratemenu.select(5, setrating)
    ratemenu.send(rm_userid)

def setrating(rm_userid, rm_choice, rm_popup):
    mapkey = keyvalues.KeyValues(name=str(rm_map))
    mapkey.load(rm_path)
    if rm_choice == 1:
        rm_stars = "fivestars"
    if rm_choice == 2:
        rm_stars = "fourstars"
    if rm_choice == 3:
        rm_stars = "threestars"
    if rm_choice == 4:
        rm_stars = "twostars"
    if rm_choice == 5:
        rm_stars = "onestars"
    rm_steamid = es.getplayersteamid(rm_userid)
    mapkey[rm_steamid] = keyvalues.KeyValues(name=str(rm_steamid))
    mapkey[rm_steamid]["Rated"] = rm_choice
    rm_count = mapkey[rm_stars]["count"]
    rm_count = int(rm_count)
    rm_count += 1
    mapkey[rm_stars]["count"] = rm_count
    mapkey.save(rm_path)
    es.tell(rm_userid, "#multi", "#green[RateMap]#default Thanks for rating #lightgreen%s#default!" % rm_map)
    getrating(rm_userid, rm_map, 1)

def getrating(rm_userid, rm_map2, rm_announce):
    mapkey = keyvalues.KeyValues(name=str(rm_map2))
    rm_path2 = es.getAddonPath('ratemap') + "/data/" + rm_map2 + '.dat'
    if not os.path.exists(rm_path2):
        if rm_announce == 1:
            es.tell(rm_userid, "#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default hasn't been rated or doesn't exist.")
    else:
        mapkey.load(rm_path2)
        rm_fivestars = mapkey["fivestars"]["count"]
        rm_fourstars = mapkey["fourstars"]["count"]
        rm_threestars = mapkey["threestars"]["count"]
        rm_twostars = mapkey["twostars"]["count"]
        rm_onestars = mapkey["onestars"]["count"]
        rm_total_fivestars = int(rm_fivestars) * 5
        rm_total_fourstars = int(rm_fourstars) * 4
        rm_total_threestars = int(rm_threestars) * 3
        rm_total_twostars = int(rm_twostars) * 2
        rm_total_onestars = int(rm_onestars) * 1
        rm_total_votes = int(rm_fivestars) + int(rm_fourstars) + int(rm_threestars) + int(rm_twostars) + int(rm_onestars)
        rm_total_votes2 = int(rm_total_fivestars) + int(rm_total_fourstars) + int(rm_total_threestars) + int(rm_total_twostars) + int(rm_total_onestars)
        if rm_total_votes != 0:
            rm_map_rating = float(rm_total_votes2) / float(rm_total_votes)
            rm_map_rating = "%.2f"%rm_map_rating
            if rm_announce == 1:
                es.tell(rm_userid, "#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default: " + rm_map_rating + "/5.00.")
            if rm_announce == 2:
                es.msg("#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default: " + rm_map_rating + "/5.00.")
        else:
            if rm_announce == 1:
                es.tell(rm_userid, "#multi", "#green[RateMap]#lightgreen " + rm_map2 + "#default hasn't been rated yet.")

def player_team(event_var):
    if ratemap_onteam == 1:
        mapkey = keyvalues.KeyValues(name=str(rm_map))
        mapkey.load(rm_path)
        rm_steamid = es.getplayersteamid(event_var["userid"])
        if not rm_steamid in mapkey:
            popuprating(event_var["userid"])